SystemOrganization addCategory: #'DrGeoII-Polymorph'!

!TEasilyThemed methodsFor: '*DrGeoII-Polymorph-controls' stamp: 'HilaireFernandes 4/7/2010 10:29'!
newToolbarDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a toolbar drop list for the given model."

	^self 
		newToolbarDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: '*DrGeoII-Polymorph-controls' stamp: 'HilaireFernandes 4/7/2010 10:28'!
newToolbarDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a toolbar drop list for the given model."

	^self theme
		newToolbarDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText! !

!TEasilyThemed methodsFor: '*DrGeoII-Polymorph-controls' stamp: 'HilaireFernandes 4/7/2010 10:30'!
newToolbarDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel help: helpText
	"Answer a toolbar drop list for the given model."

	^self 
		newToolbarDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		useIndex: true
		help: helpText! !

PluggableMorphListMorph subclass: #PluggableToolbarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!PluggableToolbarMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 7/2/2010 18:47'!
mouseUp: event 
	"The mouse came up within the list; take appropriate action"
	
	| row mdr |
	row := self rowAtLocation: event position.
	event hand hasSubmorphs ifFalse: [
		mdr := self mouseDownRow.
		 self mouseDownRow: nil.
		mdr ifNil: [^self]].
	(self enabled and: [model okToChange])
		ifFalse: [^ self].
	self changeModelSelection: row.
	Cursor normal show! !

!TextMorph methodsFor: '*DrGeoII-Polymorph-extentions' stamp: 'HilaireFernandes 9/19/2012 16:17'!
drawDropShadowOn: aCanvas
	| fauxBounds oldColor range|
	(self startingIndex > text size)
		ifTrue: [self drawNullTextOn: aCanvas].
	fauxBounds := self bounds topLeft corner: self innerBounds bottomRight.
	fauxBounds := fauxBounds translateBy: self shadowOffset.
	oldColor := self textColor.
	self textColor: self shadowColor.
	aCanvas paragraph: self paragraph bounds: fauxBounds color: self shadowColor.
	self textColor: oldColor.! !

UIThemeWatery2 subclass: #DrGeoTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!DrGeoTheme class methodsFor: 'accessing' stamp: 'HilaireFernandes 6/15/2011 15:24'!
themeName
	"Answer the friendly name of the theme."

	^'Dr. Geo'! !

!DrGeoTheme methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/15/2011 16:25'!
configureWindowBorderFor: aWindow
	aWindow borderWidth: 0! !

!DrGeoTheme methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/15/2011 16:17'!
createCloseBoxFor: aSystemWindow
	^ MultistateButtonMorph new extent: 0@0! !

!DrGeoTheme methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/15/2011 16:17'!
createCollapseBoxFor: aSystemWindow
	^ MultistateButtonMorph new extent: 0@0! !

!DrGeoTheme methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/15/2011 16:17'!
createExpandBoxFor: aSystemWindow
	^ MultistateButtonMorph new extent: 0@0! !

!DrGeoTheme methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/15/2011 16:17'!
createMenuBoxFor: aSystemWindow
	^ MultistateButtonMorph new extent: 0@0! !

!DrGeoTheme methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/15/2011 16:28'!
initialize
	"Initialize the receiver."

	super initialize.
	self windowActiveDropShadowStyle: #nodiffuse! !

!DrGeoTheme methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/29/2011 08:28'!
newToolSpacerIn: aThemedMorph
	"Answer a new tool spacer."

	^Morph new
		borderWidth: 0;
		color: Color transparent;
		extent: 6@6! !

PackageInfo subclass: #DrGDistroInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!DrGDistroInfo class methodsFor: 'cleanup' stamp: 'HilaireFernandes 4/5/2012 18:58'!
cleanUpForRelease 
	"self cleanUpForRelease"

	(MCPackage named: 'Announcements-Help') unload.
	(MCPackage named: 'FileSystem-Tests-Disk') unload.
	(MCPackage named: 'FileSystem-Tests-Memory') unload.
	(MCPackage named: 'FileSystem-Tests-Core') unload.
	(MCPackage named: 'FileSystem-Tests-AnsiStreams') unload.
	(MCPackage named: 'Metacello-Help') unload.
	(MCPackage named: 'Regex-Help') unload.

	RecentMessageList cleanUp.
	Smalltalk removeEmptyMessageCategories.
	Smalltalk garbageCollect! !

!DrGDistroInfo class methodsFor: 'cleanup' stamp: ''!
cleanUpForReleaseTablet
" self cleanUpForReleaseIPad "
	(MCPackage named: 'Tools-Explorer') unload.
	(MCPackage named: 'Tools-FileList') unload.
	(MCPackage named: 'Tools-File Contents Browser') unload.
	(MCPackage named: 'Tools-Inspector') unload.
	(MCPackage named: 'Tools-Process Browser') unload.
	(MCPackage named: 'Tools-Process') unload.
	(MCPackage named: 'Finder-UI') unload.
	(MCPackage named: 'Graphics-Resources') unload.
	Smalltalk removeEmptyMessageCategories .
	Smalltalk garbageCollect	! !

!DrGDistroInfo class methodsFor: 'cleanup' stamp: 'HilaireFernandes 4/5/2012 18:59'!
cleanUpForReleaseWithoutDrGeoUpdate
" self cleanUpForReleaseWithoutDrGeoUpdate "
	(MCPackage named: 'Zinc-HTTP') unload.
	(MCPackage named: 'Gofer-Core') unload.
	(MCPackage named: 'Metacello') unload.
	(MCPackage named: 'MonticelloGUI') unload.
	(MCPackage named: 'MonticelloConfiguration') unload.
	(MCPackage named: 'ConfigurationOfGettext') unload.
	(MCPackage named: 'ConfigurationOfGofer') unload.
	(MCPackage named: 'ConfigurationOfHelpSystem') unload.
	(MCPackage named: 'ConfigurationOfMetacello') unload.
	(MCPackage named: 'ConfigurationOfOCompletion') unload.
	(MCPackage named: 'ConfigurationOfShout') unload.
	(MCPackage named: 'ConfigurationOfXMLSupport') unload.

	Smalltalk removeEmptyMessageCategories .
	Smalltalk garbageCollect	! !

!DrGDistroInfo class methodsFor: 'class initialization' stamp: 'HilaireFernandes 2/1/2008 09:58'!
initialize
	super initialize.
	Smalltalk
		at: #TextDomainManager
		ifPresent: [:textDomainManager | textDomainManager registerCategoryPrefix: 'DrGeoII' domain: 'DrGeoII']! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'jlrr 9/30/2007 19:57'!
makeSAR
	"
	DrGeoDistroInfo makeSAR
	
	Translations must be at po/DrGeoII directory
	mcz file must be at DrGeoII directory
	"
	| sar result sarName |
	sar := ZipArchive new.
	self mczFullFileNames
		do: [:fileName | fileName
				ifNotNil: [sar
						addFile: fileName
						as: (FileDirectory localNameFor: fileName)]].
	self poFullFileNames
		do: [:fileName | fileName
				ifNotNil: [sar addFile: 'po/DrGeoII/' , fileName]].
	sar addString: self preambleText as: 'install/preamble'.
	sar addString: self postscriptText as: 'install/postscript'.
	result := StandardFileMenu newFile.
	result
		ifNil: [^ nil].
	sarName := result directory fullNameFor: result name.
	sar writeToFileNamed: sarName! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'jlrr 9/30/2007 18:28'!
mczBaseFileNames
	"DrGeoDistroInfo mczBaseFileNames"
	^ self mczFullFileNames
		collect: [:ea | 
			ea ifNotNil:[
			FileDirectory localNameFor: ea]]! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'jlrr 9/30/2007 18:27'!
mczFullFileNames
	"DrGeoDistroInfo mczFullFileNames"
	| dir lastName |
	dir := FileDirectory default directoryNamed: 'DrGeoII'.
	^ self mczPackages
		collect: [:s | 

			{dir}
				detect: [:d | (lastName := d lastNameFor: s extension: 'mcz') notNil]
				ifNone: [].
			dir fullNameFor: lastName]! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'jlrr 9/30/2007 17:55'!
mczPackages
	^ {'DrGeoII-jlrr'. 'DrGeoII-HilaireFernandes'}! !

!DrGDistroInfo class methodsFor: 'objects from disk' stamp: 'HilaireFernandes 2/1/2008 10:27'!
openExamplesTable
	| morph button |
	morph := BorderedMorph new.
	morph changeTableLayout; listDirection: #leftToRight; hResizing: #shrinkWrap; vResizing: #shrinkWrap; color: Color green veryMuchLighter; layoutInset: 5; cellInset: 5; wrapDirection: #toToBottom; borderColor: #complexFramed; borderWidth: 5.
	(FileDirectory on: DrGDefault examplesPath) fileNames
		do: [:file | 
			button := SimpleButtonMorph
						newWithLabel: (file copyUpTo: $.).
			button target: DrGDistroInfo;
				 actionSelector: #viewXml:;
				 arguments: {file}.
			morph addMorph: button].
	morph openInWorld! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'jlrr 9/30/2007 19:19'!
poBaseFileNames
	"DrGeoDistroInfo poBaseFileNames"
	^ self poFullFileNames
		collect: [:ea | ea
				ifNotNil: [FileDirectory localNameFor: ea]]! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'jlrr 9/30/2007 19:11'!
poFullFileNames
	"DrGeoDistroInfo poFullFileNames"
	| dir |
	dir := FileDirectory default directoryNamed: 'po/DrGeoII'.
	

		
		
	^ dir fileNamesMatching:'*.po'
		! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'jlrr 9/30/2007 17:31'!
postscriptText
	^ ''! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'jlrr 11/13/2007 11:42'!
preambleText
	"
	DrGeoDistroInfo preambleText
	"
	| basename |
	^ String
		streamContents: [:stream | 
			self mczBaseFileNames
				do: [:pkgName | pkgName
						ifNotNil: [stream nextPutAll: 'self fileInMonticelloZipVersionNamed: ';
								 print: pkgName;
								 nextPut: $.;
								 cr]].
			stream nextPutAll:'(self membersMatching: ''po/DrGeoII/*.po'')
         do: [ :f | self extractMember: f ].';nextPut: $.;
								 cr.
			self poBaseFileNames
				do: [:poName | poName
						ifNotNil: [basename := FileDirectory baseNameFor: poName.
							stream nextPutAll: 'GetTextImporter new import:(NaturalLanguageTranslator
availableForLocaleID: (LocaleID isoLanguage:''' , basename , '''))
fileNamed:';
								 print: 'po/DrGeoII/' , poName;
								 nextPut: $.;
								 cr]]]! !

!DrGDistroInfo class methodsFor: 'distribution' stamp: 'HilaireFernandes 8/3/2011 18:58'!
saveAsIPadImage: imageName
	" DrGeo saveAsIPadImage: 'drgeo.image' "
	DrGDefault beiPadMode.
	World submorphs do: [:m | m delete].
	World color: Color white.
	HostWindowProxy basicNew primitiveWindowSize: 1 x: 1024 y: 768.
	World doOneCycleNow.
	DrGeo newFullScreen.
	SmalltalkImage checkSourcesFileAvailability: false.
	SmalltalkImage checkChangesFileAvailability: false.
	MCHttpRepository clearPasswords.
	MCFileBasedRepository flushAllCaches.
	SmalltalkImage current saveAs: imageName.
! !

!DrGDistroInfo class methodsFor: 'objects from disk' stamp: 'HilaireFernandes 2/1/2008 10:16'!
viewXml: filename 
	DrGeo serviceViewXml: DrGDefault examplesPath , FileDirectory slash , filename! !

DialogWindow subclass: #DrGFileThumbnailWindow
	instanceVariableNames: 'resource isExamples previewsPanel finalSelectedFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!DrGFileThumbnailWindow commentStamp: 'HilaireFernandes 12/17/2011 21:58' prior: 0!
I am a dialog to browse sketches. I present a sketch preview the user can select.
Sketches are locale or remote.
	- resource is the way to access these sketches, it is a DrGDirectory instance.!

!DrGFileThumbnailWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 3/21/2012 08:42'!
beDelete
	^ self isExamples not & self selectedFile notNil! !

!DrGFileThumbnailWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 8/2/2011 12:49'!
beExamples
	^ true! !

!DrGFileThumbnailWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 8/2/2011 12:49'!
beMySketches 
	^ true! !

!DrGFileThumbnailWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 12/17/2011 21:47'!
beNetwork
	^ true! !

!DrGFileThumbnailWindow methodsFor: 'preview cache' stamp: 'HilaireFernandes 12/18/2011 10:52'!
cachePreviewFilename: filename
	"the name of the cahed preview if it exist"
	^ ((filename allButLast: 4), 'png')! !

!DrGFileThumbnailWindow methodsFor: 'preview cache' stamp: 'HilaireFernandes 12/18/2011 10:55'!
cachedFormFor: filename
	^ PNGReadWriter formFromStream:  (resource getFile: (self cachePreviewFilename: filename))! !

!DrGFileThumbnailWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 3/21/2012 08:22'!
cancelButton
|btns|
	btns := self buttons.
	^ btns at: btns size - 1! !

!DrGFileThumbnailWindow methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 10/14/2012 18:41'!
closeResource
	resource ifNotNil: [resource close]! !

!DrGFileThumbnailWindow methodsFor: 'preview cache' stamp: 'HilaireFernandes 12/21/2011 09:10'!
computeFormFor: filename
	|stream drgeo form|
	stream := resource getTextFile: filename.
	[	[drgeo := (DrGeoXml new loadOnlyFigureFrom: stream for: #service) first.
		drgeo view 
			extent: 800@600;
	 		right: 0; 
			openInWorld; 
			delete]on: Error do: []
	] ensure: [stream close].
	form := drgeo ifNil: [Form extent: 1@1] ifNotNil: [drgeo area imageForm scaledToSize: DrGeo previewSize].
	form := form asFormOfDepth: 8.
	[stream := ByteArray new writeStream.
	PNGReadWriter putForm: form onStream: stream.
	resource put: stream into: (self cachePreviewFilename: filename)] ensure:
		[stream close].
	^ form! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 6/22/2011 14:56'!
defaultLabel
	^ 'Open a sketch' translated! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 3/21/2012 08:54'!
deleteFile
|answer|
		answer := UIManager default 
			confirm: ('Delete the sketch: {1}?' translated format: {(self selectedFile allButLast: 5) capitalized}).
		answer ifTrue: [
			resource deleteFile: self selectedFile.
			resource deleteFile: (self selectedFile allButLast: 4), 'png'.
			previewsPanel removeMorph: self rememberedKeyboardFocus.
			self focusCancelButton.
			self changed: #beDelete]! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 3/21/2012 08:49'!
focusCancelButton
	self cancelButton takeKeyboardFocus.
	self rememberKeyboardFocus: self cancelButton.
! !

!DrGFileThumbnailWindow methodsFor: 'preview cache' stamp: 'HilaireFernandes 12/18/2011 10:51'!
formFor: filename
	^ (self isCachedForm: filename) 
		ifTrue: [self cachedFormFor: filename] 
		ifFalse: [self computeFormFor: filename]! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 4/5/2012 20:41'!
gotFocusOn: previewMorph
	self rememberKeyboardFocus: previewMorph.
	self changed: #beDelete.
! !

!DrGFileThumbnailWindow methodsFor: 'open/close' stamp: 'HilaireFernandes 3/30/2012 08:06'!
initialExtent
	^ 700@ 400! !

!DrGFileThumbnailWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 3/14/2012 20:24'!
initialize
	resource := DrGDefault mySketchResources.
	super initialize.
! !

!DrGFileThumbnailWindow methodsFor: 'preview cache' stamp: 'HilaireFernandes 12/18/2011 10:53'!
isCachedForm: filename
	^ resource fileExists: (self cachePreviewFilename: filename)! !

!DrGFileThumbnailWindow methodsFor: 'testing' stamp: 'HilaireFernandes 12/17/2011 22:31'!
isExamples
	^ resource isLocal and: [resource directory includesSubString: 'examples']! !

!DrGFileThumbnailWindow methodsFor: 'testing' stamp: 'HilaireFernandes 12/17/2011 22:36'!
isMySketches
	^ resource isLocal and: [resource directory includesSubString: 'MySketches']! !

!DrGFileThumbnailWindow methodsFor: 'testing' stamp: 'HilaireFernandes 12/17/2011 22:37'!
isNetwork
	"are we browsing the networked sketch"
	^ resource isRemote ! !

!DrGFileThumbnailWindow methodsFor: 'update' stamp: 'HilaireFernandes 5/4/2012 22:39'!
loadPreviews
	DrGLoader start.
	[previewsPanel removeAllMorphs.
	resource fgeoFiles reverse
		do: [:file | previewsPanel addMorph: (self previewFor: file)]
	] 
	ensure: [
		DrGLoader stop].! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 3/20/2012 16:28'!
newButtons
	|buttons|
	buttons := OrderedCollection withAll: {self newMySketchesButton. self newExamplesButton}.
	DrGDefault useNetwork ifTrue: [buttons add: self newNetworkButton].
	buttons addAll: {
		Morph new color: Color transparent; hResizing: #spaceFill; height: 10.
		self newOpenButton. self newCancelButton isDefault: true. self newDeleteButton}.
	^ buttons! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 8/2/2011 13:51'!
newContentMorph
| scroll|
	previewsPanel := PanelMorph new color: Color white.
	previewsPanel hResizing: #spaceFill;
		vResizing: #spaceFill;
		changeTableLayout;
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		cellInset: 8.
	self loadPreviews.
	scroll := GeneralScrollPane new
		changeScrollerTableLayout;
		scrollTarget: previewsPanel.
	^ scroll vResizing: #spaceFill;
		hResizing: #spaceFill! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 3/21/2012 09:06'!
newDeleteButton
	^ (self 
		newButtonFor: self
		getState: nil
		action: #deleteFile
		arguments: nil
		getEnabled: #beDelete
		labelForm: self theme smallDeleteIcon
		help: 'Delete the selected sketch' translated) hResizing: #shrinkWrap! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 12/17/2011 22:44'!
newExamplesButton
	^ self newButtonFor: self
		getState: #isExamples
		action: #switchToExamples 
		arguments: nil
		getEnabled: #beExamples 
		label: 'Examples' translated 
		help: 'View sketch examples' translated! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 12/17/2011 22:44'!
newMySketchesButton
	^ self newButtonFor: self
		getState: #isMySketches
		action: #switchToSketches 
		arguments: nil
		getEnabled: #beMySketches 
		label: 'MySketches' translated 
		help: 'View my sketches' translated! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 12/18/2011 11:41'!
newNetworkButton
	^ self newButtonFor: self
		getState: #isNetwork
		action: #switchToNetwork
		arguments: nil
		getEnabled: #beNetwork 
		label: 'Network' translated 
		help: 'View shared sketches' translated! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 6/22/2011 14:54'!
newOpenButton
	^ self 
		newButtonFor: self
		action: #ok 
		label: 'Open' translated 
		help: 'Open the selected sketch' translated! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: ''!
ok
	finalSelectedFile := self selectedFile.
	^ super ok! !

!DrGFileThumbnailWindow methodsFor: 'preview cache' stamp: 'HilaireFernandes 3/21/2012 08:14'!
previewFor: filename
	| morph|
	morph := ThumbnailPreviewMorph new
		filename: filename;
		image: (self formFor: filename)
		size: DrGeo previewSize.
	morph textMorph contents: (filename allButLast: 5) capitalized.
	morph when: #selectedSktech send: #selectAndClose to: self.
	morph when: #gotFocus send: #gotFocusOn: to: self.
	^ morph! !

!DrGFileThumbnailWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 6/24/2011 16:18'!
previewSize 
	^ 320@240! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 6/24/2011 09:48'!
selectAndClose
	self ok.! !

!DrGFileThumbnailWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 6/24/2011 09:22'!
selectedFile
	"a DirectoryEntryFile item"
	| focusedMorph |
	focusedMorph := self rememberedKeyboardFocus.
	^ (focusedMorph respondsTo: #filename) 
		ifTrue: [focusedMorph filename]
		ifFalse: [nil]
	! !

!DrGFileThumbnailWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 3/26/2012 21:43'!
selectedFileStream
	^ resource getTextFile: finalSelectedFile! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 3/21/2012 08:49'!
switchToExamples
	self focusCancelButton.
	resource :=DrGDefault exampleResources.
	self updateBtnAndPreview ! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 3/21/2012 08:49'!
switchToNetwork
	self focusCancelButton.
	DrGLoader start.
	(DrGDefault networkResources: self) ifNotNilDo: [:anwer |
		resource := anwer.
		DrGLoader stop.
		self updateBtnAndPreview].
! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 3/21/2012 08:49'!
switchToSketches
	self focusCancelButton.
	resource :=DrGDefault mySketchResources.
	self updateBtnAndPreview! !

!DrGFileThumbnailWindow methodsFor: 'actions' stamp: 'HilaireFernandes 3/21/2012 08:23'!
updateBtnAndPreview
	self changed: #isMySketches.
	self changed: #isExamples.
	self changed: #isNetwork.
	self changed: #beDelete.
	self loadPreviews ! !

ImagePreviewMorph subclass: #ThumbnailPreviewMorph
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!ThumbnailPreviewMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 6/24/2011 09:49'!
doubleClick: evt
	self wantsKeyboardFocus ifTrue: [self takeKeyboardFocus].
	self triggerEvent: #selectedSktech! !

!ThumbnailPreviewMorph methodsFor: 'drawing' stamp: 'HilaireFernandes 6/22/2011 21:54'!
drawSubmorphsOn: aCanvas
"Display submorphs back to front.
Draw the focus here since we are using inset bounds
for the focus rectangle."
	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]
! !

!ThumbnailPreviewMorph methodsFor: 'accessing' stamp: 'HilaireFernandes 6/24/2011 09:23'!
filename
	^ filename! !

!ThumbnailPreviewMorph methodsFor: 'accessing' stamp: 'HilaireFernandes 6/24/2011 09:23'!
filename: string
	filename := string ! !

!ThumbnailPreviewMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 6/22/2011 21:51'!
handlesKeyboard: event
	^ true! !

!ThumbnailPreviewMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 3/7/2012 11:53'!
handlesMouseDown: event
	^ true! !

!ThumbnailPreviewMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 3/7/2012 10:46'!
hasFocus
	^ true! !

!ThumbnailPreviewMorph methodsFor: 'nil' stamp: 'HilaireFernandes 1/5/2012 16:19'!
image: form size: imageSize
	"Set the image and update the description."
	form
		ifNil: [self imageMorph
			image: (self defaultImageFormOfSize: imageSize)]
		ifNotNil: [self imageMorph
			image: form
			size: imageSize]
	! !

!ThumbnailPreviewMorph methodsFor: 'initialize' stamp: 'HilaireFernandes 3/10/2012 09:11'!
initialize 
	super initialize.
	self cellInset: 4.
	self cornerStyle: #rounded.
	self hasDropShadow: true.
	self shadowOffset: 1@1.
	self shadowColor: (Color black alpha: 0.2).
	self layoutChanged.! !

!ThumbnailPreviewMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 6/22/2011 21:58'!
keyStroke: event
"Process keys navigation and space to toggle."
	(self navigationKey: event) ifTrue: [^self]. ! !

!ThumbnailPreviewMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 3/21/2012 08:14'!
keyboardFocusChange: aBoolean
	self focusChanged.
	aBoolean ifTrue: [self triggerEvent: #gotFocus with: self]
! !

!ThumbnailPreviewMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 3/21/2012 07:37'!
mouseDown: event
	super mouseDown: event.
	event hand waitForClicksOrDrag: self event: event.
	self wantsKeyboardFocus ifTrue: [self takeKeyboardFocus]! !

!ThumbnailPreviewMorph methodsFor: 'event handling' stamp: 'HilaireFernandes 3/8/2012 21:29'!
mouseMove: evt
"hugly, pass the move event to the GeneralScrollPane"
	self owner owner owner mouseMove: evt! !

!ThumbnailPreviewMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 3/10/2012 09:07'!
newImageMorph
	"Answer a new image morph."

	^AlphaImageMorph new
		borderStyle: (BorderStyle raised width: 1);
		color: Color white;
		alpha: 1.0! !

!ThumbnailPreviewMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 3/10/2012 09:07'!
newTextMorph 
	^ super newTextMorph
		hasDropShadow: true;
		shadowOffset: 1@1;
		color: Color white.
		! !

!ThumbnailPreviewMorph methodsFor: '*DrGeoII-Polymorph-Widgets' stamp: 'HilaireFernandes 6/25/2011 08:44'!
takesKeyboardFocus 
	^ true! !

BorderedMorph subclass: #UnderMouseMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!UnderMouseMorph commentStamp: 'HilaireFernandes 11/19/2012 14:20' prior: 0!
I display on the top left or right corner of my owner what is under the Active hand!

!UnderMouseMorph methodsFor: 'drawing' stamp: 'HilaireFernandes 11/19/2012 18:25'!
drawOn: aCanvas
	| areaUnderHand |
	super drawOn: aCanvas.
	areaUnderHand := Form fromDisplay: (Rectangle 
			center: ActiveHand position 
			extent: self extent - (self borderWidth * 2)).
	aCanvas drawImage: areaUnderHand at: self position + self borderWidth! !

MessageDialogWindow subclass: #CoordinatesEditorDialogWindow
	instanceVariableNames: 'xTextEditorMorph yTextEditorMorph xEntryText yEntryText'
	classVariableNames: 'MinimumWidth'
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!CoordinatesEditorDialogWindow class methodsFor: 'settings' stamp: 'HilaireFernandes 10/27/2011 22:47'!
minimumWidth
	^ MinimumWidth ifNil: [MinimumWidth := 450]! !

!CoordinatesEditorDialogWindow class methodsFor: 'settings' stamp: 'HilaireFernandes 10/27/2011 22:47'!
minimumWidth: anInteger
	MinimumWidth := anInteger! !

!CoordinatesEditorDialogWindow class methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 10/27/2011 22:53'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme  smallQuestionIcon! !

!CoordinatesEditorDialogWindow methodsFor: 'actions' stamp: 'HilaireFernandes 10/27/2011 22:54'!
cancel
	"Cancel and close."

	self xEntryText: nil.
	self yEntryText: nil.
	^super cancel! !

!CoordinatesEditorDialogWindow methodsFor: 'focus handling' stamp: 'HilaireFernandes 10/27/2011 22:53'!
defaultFocusMorph
	"Answer the morph that should have the keyboard
	focus by default when the dialog is opened."
	
	^self xTextEditorMorph textMorph! !

!CoordinatesEditorDialogWindow methodsFor: 'visual properties' stamp: 'HilaireFernandes 10/27/2011 22:42'!
entryHeight: aNumber
	"Set the height of the text editor morph.
	Set the width to be 2 times this also."

	self xTextEditorMorph
		vResizing: #rigid;
		height: aNumber;
		hResizing: #rigid;
		width: aNumber * 2.
	self yTextEditorMorph
		vResizing: #rigid;
		height: aNumber;
		hResizing: #rigid;
		width: aNumber * 2! !

!CoordinatesEditorDialogWindow methodsFor: 'visual properties' stamp: 'HilaireFernandes 10/27/2011 22:41'!
icon
	"Answer an icon for the receiver."
	
	^self theme questionIcon! !

!CoordinatesEditorDialogWindow methodsFor: 'open/close' stamp: 'HilaireFernandes 10/27/2011 22:46'!
initialExtent
	^ self minimumWidth @ (super initialExtent y)
! !

!CoordinatesEditorDialogWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 10/27/2011 22:43'!
initialize
	"Initialize the receiver."

	super initialize.
	self xEntryText: ''.
	self yEntryText: ''! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:47'!
minimumWidth
	^ (super minimumWidth max: self class minimumWidth) min: (Display width)! !

!CoordinatesEditorDialogWindow methodsFor: 'actions' stamp: 'HilaireFernandes 10/27/2011 22:45'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton isDefault: true. self newCancelButton}! !

!CoordinatesEditorDialogWindow methodsFor: 'actions' stamp: 'HilaireFernandes 10/27/2011 23:08'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	self textMorph wrapFlag: false.
	self xTextEditorMorph: self newXTextEditorMorph.
	self yTextEditorMorph: self newYTextEditorMorph.
	^self newGroupboxForAll: {
		self newRow: {self iconMorph. self textMorph}.
		self newRow: {self newTextMorph contents: 'X =' . self xTextEditorMorph}.
		self newRow: {self newTextMorph contents: 'Y ='. self yTextEditorMorph}}! !

!CoordinatesEditorDialogWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 10/27/2011 22:50'!
newXTextEditorMorph
	"Answer a new text entry morph."

	^(self
		newTextEntryFor: self
		getText: #xEntryText
		setText: #xEntryText:
		getEnabled: nil
		help: nil)
		acceptOnCR: false;
		selectAll! !

!CoordinatesEditorDialogWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 10/27/2011 22:50'!
newYTextEditorMorph
	"Answer a new text entry morph."

	^(self
		newTextEntryFor: self
		getText: #yEntryText
		setText: #yEntryText:
		getEnabled: nil
		help: nil)
		acceptOnCR: false;
		selectAll! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:38'!
xEntryText
	^ xEntryText ! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:40'!
xEntryText: anObject
	"Set the value of xEntryText"

	xEntryText := anObject.
	self changed: #xEntryText.
	self xTextEditorMorph selectAll! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:38'!
xTextEditorMorph
	^ xTextEditorMorph! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:39'!
xTextEditorMorph: anObject
	xTextEditorMorph := anObject! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:38'!
yEntryText
	^ yEntryText ! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:39'!
yEntryText: anObject
	"Set the value of yEntryText"

	yEntryText := anObject.
	self changed: #yEntryText.
	self yTextEditorMorph selectAll! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:39'!
yTextEditorMorph
	^ yTextEditorMorph! !

!CoordinatesEditorDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 10/27/2011 22:39'!
yTextEditorMorph: anObject
	yTextEditorMorph := anObject! !

!UITheme methodsFor: '*DrGeoII-Polymorph-morph creation' stamp: 'HilaireFernandes 4/7/2010 10:18'!
newToolbarDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a toolbar drop list for the given model."

	^self
		newToolbarDropListIn: aThemedMorph
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!UITheme methodsFor: '*DrGeoII-Polymorph-morph creation' stamp: 'HilaireFernandes 4/7/2010 10:15'!
newToolbarDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a toolbar drop list for the given model."

	^(ToolbarDropListMorph
			on: aModel
			list: listSel
			selected: getSel
			changeSelected: setSel
			useIndex: useIndex)
		selectionColor: self selectionColor;
		getEnabledSelector: enabledSel;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

StandardWindow subclass: #DrGeoWindow
	instanceVariableNames: 'app area toolbars pointToolbar numericToolbar macroToolbar curveToolbar transformationToolbar statusbar miscToolbar sideContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!DrGeoWindow commentStamp: '<historical>' prior: 0!
A DrGeoWindow is xxxxxxxxx.

Instance Variables
	app:		<Object>
	area:		<Object>
	curveToolbar:		<Object>
	macroToolbar:		<Object>
	miscToolbar:		<Object>
	numericToolbar:		<Object>
	pointToolbar:		<Object>
	statusbar:		<Object>
	toolbars:		<Object>
	transformationToolbar:		<Object>
	sideContainer:	a row alignement morph


sideContainer 
	- holds in a row the drawing area and the toolbox to edit object attributes

app
	- xxxxx

area
	- the drawing area

curveToolbar
	- xxxxx

macroToolbar
	- xxxxx

miscToolbar
	- xxxxx

numericToolbar
	- xxxxx

pointToolbar
	- xxxxx

statusbar
	- xxxxx

toolbars
	- xxxxx

transformationToolbar
	- xxxxx
!

!DrGeoWindow class methodsFor: 'initialize-release' stamp: 'HilaireFernandes 4/18/2010 22:54'!
in: aDrGeo 
	"A new model with an existing domain. For multiple MVP on a same
	Domain "
	^ super basicNew app: aDrGeo;
		 initialize! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 7/26/2012 09:54'!
addMenuItem: array to: menu
	menu 
		addToggle: array first 
		target: self presenter
		selector: array third.
	menu lastItem
		font: self theme menuFont;
		setBalloonText: array fourth.
	"do we have a stock icon for this tool?"
	(DrGIcons respondsTo: array second) ifFalse: [^self].

	(DrGDefault isSugar or: [app isToolbarless]) ifFalse: [
		menu lastItem icon: (DrGIcons scaled: array second to: 16)]  ! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/5/2012 20:40'!
addState: stateSymbol menuItem: array to: menu
	menu 
		addToggle: array first 
		target: self presenter
		selector: array third
		getStateSelector: stateSymbol.
	menu lastItem
		font: self theme menuFont;
		setBalloonText: array fourth.
	menu lastItem icon: (DrGIcons scaled: array second to: 16) ! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 8/25/2012 17:58'!
additionalToolbar
	|tools collection|
	collection := OrderedCollection withAll: {
		self buttonWith: self presenter newButtonData.
		self buttonWith: self presenter openButtonData.
		self buttonWith: self presenter keepButtonData.
		self newToolSpacer. self newToolSpacer.
		self buttonWith: self presenter undoButtonData.
		self buttonWith: self presenter redoButtonData.
		self newToolSpacer. self newToolSpacer.
		self buttonWithState: self presenter gridButtonData.
		self buttonWithState: self presenter gridStuckButtonData.      
		self newToolSpacer. self newToolSpacer.
		self buttonWithState: self presenter multipleModeButtonData.
		self buttonWith: self presenter moveButtonData.
		self newToolSpacer. self newToolSpacer.
		self buttonWith: self presenter eraserButtonData.
		self buttonWith: self presenter styleButtonData.
		self buttonWith: self presenter propertyButtonData}.
	DrGDefault ifNotiPad: [
		collection addAll: {
			self horizontalExpander.
			self buttonWith: {'Quit' translated. #quit. #quit. 'Quit' translated}}].
	tools := self newToolbar: collection.
	tools hResizing: #spaceFill.
	^ self newToolDockingBar addMorph: tools.
! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2010 22:49'!
app 
	^ app ! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2010 22:53'!
app: aDrgeo
	app := aDrgeo! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/19/2010 12:39'!
area
	^ area! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 3/25/2011 21:32'!
button: selectedTool with: array 
	^ self
		button: selectedTool
		with: array
		state: #isTool:! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 3/25/2011 21:32'!
button: selectedTool with: array state: state 

	^ self
		newButtonFor: self presenter
		getState: state
		action: array third
		arguments: {selectedTool}
		getEnabled: nil
		labelForm: (self buttonIcon: array second)
		help: array fourth! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 1/31/2012 16:38'!
buttonIcon: selector
	^ DrGDefault isWorkstation
		ifTrue: [DrGIcons scaled: selector to: 24]
		ifFalse: [DrGIcons scaled: selector to: DrGDefault toolbarIconSize]! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 3/25/2011 21:23'!
buttonWith: array 
	"array first = menu label or button label
	array second = button form = selection mode
	array third = symbol callback
	array fourth = help string
	"
	^ self button: array second with: array! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 3/25/2011 21:32'!
buttonWithState: array 
	"array first = menu label or button label
	array second = button form = selection mode
	array third = symbol callback
	array fourth = help string
	array fifth=state
	"
	^ self button: array second with: array  state:   array fifth
! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 7/2/2010 16:18'!
curveButtons
	^{
	self buttonWith: self presenter lineButtonData.
	self buttonWith: self presenter parallelButtonData.
	self buttonWith: self presenter perpendicularButtonData.
	self buttonWith: self presenter rayButtonData.
	self buttonWith: self presenter segmentButtonData.
	self buttonWith: self presenter vectorButtonData.
	self buttonWith: self presenter circleButtonData.
	self buttonWith: self presenter arcButtonData.
	self buttonWith: self presenter polygonButtonData.
	self buttonWith: self presenter locusButtonData 
	}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 8/18/2012 16:27'!
curveMenu
	| lineMenu |
	lineMenu := self newMenu.
	self addMenuItem: self presenter lineButtonData to: lineMenu.
	self addMenuItem: self presenter parallelButtonData to: lineMenu.
	self addMenuItem: self presenter perpendicularButtonData to: lineMenu.
	self addMenuItem: self presenter perpendicularBisectorButtonData to: lineMenu.
	self addMenuItem: self presenter angleBisectorButtonData to: lineMenu.
	self addMenuItem: self presenter rayButtonData to: lineMenu.
	self addMenuItem: self presenter segmentButtonData to: lineMenu.
	self addMenuItem: self presenter vectorButtonData to: lineMenu.
	self addMenuItem: self presenter circleButtonData to: lineMenu.
	self addMenuItem: self presenter arcButtonData to: lineMenu.
	self addMenuItem: self presenter arcCenterButtonData to: lineMenu.
	self addMenuItem: self presenter polygonButtonData to: lineMenu.
	self addMenuItem: self presenter locusButtonData to: lineMenu.
	^ lineMenu
		! !

!DrGeoWindow methodsFor: 'tabular groups' stamp: 'HilaireFernandes 8/18/2012 16:27'!
curveTab
	^ self newTable:  {
		self toolButtonFor: self presenter lineButtonData.
		self toolButtonFor: self presenter parallelButtonData .
		self toolButtonFor: self presenter perpendicularButtonData .
		self toolButtonFor: self presenter perpendicularBisectorButtonData .
		self toolButtonFor: self presenter angleBisectorButtonData .
		self toolButtonFor: self presenter rayButtonData .
		self toolButtonFor: self presenter segmentButtonData .
		self toolButtonFor: self presenter vectorButtonData .
		self toolButtonFor: self presenter circleButtonData .
		self toolButtonFor: self presenter arcButtonData .
		self toolButtonFor: self presenter arcCenterButtonData .
		self toolButtonFor: self presenter polygonButtonData .
		self toolButtonFor: self presenter locusButtonData }! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 7/3/2010 09:58'!
curveToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ curveToolbar ifNil: [
		curveToolbar := (self 
			newToolbarDropListFor:  (ListModel new list: self curveButtons )
			list: #list 
			getSelected: #selectionIndex 
			setSelected: #selectionIndex: 
			help: 'Create different curve types: line, half-line, segment, vector, circle...' translated)]! !

!DrGeoWindow methodsFor: 'open/close' stamp: 'HilaireFernandes 10/4/2010 21:26'!
delete
	(self 
		questionWithoutCancel: 'Are you sure to close this sketch?' translated 
		title: 'Closing sketch' translated) ifTrue:
		[super delete.
		app ifNotNil: [app release]]! !

!DrGeoWindow methodsFor: 'open/close' stamp: 'HilaireFernandes 10/4/2010 21:22'!
deleteWithoutConfirmation
	super delete.
	app release ! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2010 22:52'!
domain
	^ app domain ! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 1/25/2012 20:29'!
editMenu
	| menu |
	menu := self newMenu.
	self addMenuItem: self presenter moveButtonData to: menu.
	self addState: #isCreateMultipleMode menuItem: self presenter multipleModeButtonData to: menu.
	self addMenuItem: self presenter undoButtonData to: menu.
	self addMenuItem: self presenter redoButtonData to: menu.
	self addMenuItem: self presenter eraserButtonData to: menu.
	self addMenuItem: self presenter styleButtonData to: menu.
	self addMenuItem: self presenter propertyButtonData  to: menu.
	self addState: #isGridVisible menuItem: self presenter gridButtonData to: menu.
	self addState: #isGridded menuItem: self presenter gridStuckButtonData to: menu.
	^ menu
		! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 1/25/2012 20:33'!
fileMenu
	| fileMenu |
	fileMenu := self newMenu.
	fileMenu
		addToggle: 'New' translated
		target: self presenter
		selector: #newFigure.
	fileMenu 
		addToggle: 'Change title' translated
		target: self
		selector: #relabel.
	fileMenu 
		addToggle: 'Open' translated
		target: self presenter
		selector: #openNewFigureThumbnail. 
	fileMenu 
		addToggle: 'Save' translated
		target:  self presenter
		selector: #saveFigure.
	fileMenu 
		addToggle: 'Save as...' translated
		target:  self presenter
		selector: #saveFigureAs.
	fileMenu 
		addToggle: 'Save multiple' translated
		target:  self presenter
		selector: #saveMultiple.
	fileMenu
		addToggle: 'Export as bitmap' translated
		target: self presenter
		selector: #exportToBitmap.
	fileMenu 
		addToggle: 'Close sketch' translated
		target: self 
		selector: #delete.
	fileMenu
		addToggle: 'Quit' translated
		target: DrGeo
		selector: #quit.
	^ fileMenu
		! !

!DrGeoWindow methodsFor: 'services' stamp: 'HilaireFernandes 9/9/2010 16:04'!
fileOpen: title extensions: exts path: path preview: preview
	"Answer the result of a file open dialog with the given title, extensions to show, path and preview type."
	|fd|
	fd := DrGFileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerOpenFile.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^ [(self openModal: fd) answer] 
		on: Error
		do: [fd answer]
! !

!DrGeoWindow methodsFor: 'helpers' stamp: ''!
horizontalExpander
	^ Morph new color: Color transparent;
		height: 1;
		hResizing: #spaceFill;
		yourself! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 5/5/2012 16:07'!
initialize
	super initialize.
	self model: self domain.
	self setLabel: 'Dr. Geo --  ' , Date today yyyymmdd.
	area := DrGDrawable newOn: app.
	self installTools.
	self presenter move.
	app isToolbarless ifFalse: [self toolbarEvents].
	DrGDefault ifTablet: [self removeGrips].
	DrGDefault ifRelease: [self beSticky]! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 3/4/2012 10:51'!
installMenu
|menu shiftY |
	menu := self mainMenu.
	shiftY := menu minExtent y.
	self addMorph: menu
		fullFrame: (LayoutFrame
			fractions: (0 @ 0 corner: 1 @ 0)
			offsets: (0 @ 0 corner: 0 @ shiftY)).
	^ shiftY! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 7/16/2012 23:46'!
installToolbarsAndTabsAt: deltaY
|bar shiftY|
	app isToolbarless ifTrue: [^ deltaY].
	bar := self additionalToolbar.
	shiftY := deltaY.
	self addMorph: bar
		fullFrame: (LayoutFrame
			fractions: (0 @ 0 corner: 1 @ 0)
			offsets: (0 @ shiftY corner: 0 @ (shiftY + bar minExtent y))).
	shiftY := shiftY + bar minExtent y.
	bar := self toolsInTab.
	self addMorph: bar
		fullFrame: (LayoutFrame
			fractions: (0 @ 0 corner: 1 @ 0)
			offsets: (0 @ shiftY corner: 0 @ (shiftY + bar minExtent y))).
	^ shiftY + bar minExtent y.
	! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 3/4/2012 10:51'!
installToolbarsAt: deltaY
|bar shiftY|
	app isToolbarless ifTrue: [^ deltaY].
	bar := self additionalToolbar.
	shiftY := deltaY.
	self addMorph: bar
		fullFrame: (LayoutFrame
			fractions: (0 @ 0 corner: 1 @ 0)
			offsets: (0 @ shiftY corner: 0 @ (shiftY + bar minExtent y))).
	shiftY := shiftY + bar minExtent y.
	bar := self toolbars.
	self addMorph: bar
		fullFrame: (LayoutFrame
			fractions: (0 @ 0 corner: 1 @ 0)
			offsets: (0 @ shiftY corner: 0 @ (shiftY + bar minExtent y))).
	^ shiftY + bar minExtent y.
	! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 7/16/2012 23:47'!
installTools
	| bar shiftY statusY |
	sideContainer := AlignmentMorph  inARow: {area}.
	sideContainer layoutInset: 0.
	area hResizing: #spaceFill. 
	shiftY := DrGDefault isTablet ifFalse: [self installMenu] ifTrue: [0].
	shiftY := self installToolbarsAndTabsAt: shiftY.
	statusY := (self statusbar minExtent y max: DrGDefault wheelWidth) 
		max: StandardFonts defaultFont height + 4.
	self addMorph: sideContainer
		fullFrame: (LayoutFrame
			fractions: (0@ 0 corner: 1 @ 1)
			offsets: (0 @ shiftY corner: DrGDefault wheelWidth negated @ statusY negated)).
			
	self installWheelsFrom: shiftY to: statusY.
	self addMorph: self statusbar
		fullFrame: (LayoutFrame
			fractions: (0 @ 1 corner: 1 @ 1)
			offsets: (0 @ statusY negated corner: (DrGDefault wheelWidth + DrGDefault wheelHeight) negated @ 0)).
	self statusbar
		borderStyle: (BorderStyle inset width: 1);
		cornerStyle: #square.
	self themeChanged; openInWorld! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 1/31/2012 15:45'!
installWheelsFrom: shiftY to: statusY
	self  addMorph: self presenter verticalWheel
		fullFrame: (LayoutFrame
			fractions: (1 @ 1 corner: 1 @ 1)
			offsets: (DrGDefault wheelWidth negated @ (DrGDefault wheelHeight negated - statusY) corner: 0 @
				statusY negated)).
	self addMorph: self presenter horizontalWheel
		fullFrame: (LayoutFrame
			fractions: (1 @ 1 corner: 1 @ 1)
			offsets: ((DrGDefault wheelWidth + DrGDefault wheelHeight) negated @ 
				statusY negated corner: DrGDefault wheelWidth negated @ 0)).
	self addMorph: self presenter zoomWheel
		fullFrame: (LayoutFrame
			fractions: (1 @ 0 corner: 1 @ 0)
			offsets: (DrGDefault wheelWidth negated @ shiftY corner: 0 @ (shiftY + DrGDefault wheelHeight))).
! !

!DrGeoWindow methodsFor: 'testing' stamp: 'HilaireFernandes 4/19/2010 10:32'!
isApplication 
	^true! !

!DrGeoWindow methodsFor: 'testing' stamp: 'HilaireFernandes 4/19/2010 10:31'!
isService
	^false! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 8/26/2012 16:03'!
macroconstructionButtons
	^{
	self buttonWith: self presenter macroBuildButtonData.
	self buttonWith: self presenter macroExecuteButtonData}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 8/26/2012 16:02'!
macroconstructionMenu
	| menu |
	menu := self newMenu.
	self addMenuItem: self presenter macroBuildButtonData to: menu.
	self addMenuItem: self presenter macroExecuteButtonData to: menu.
	^ menu
		! !

!DrGeoWindow methodsFor: 'tabular groups' stamp: 'HilaireFernandes 8/26/2012 16:02'!
macroconstructionTab
	^ self newTable: {
		self toolButtonFor: self presenter macroBuildButtonData .
		self toolButtonFor: self presenter macroExecuteButtonData}! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 7/3/2010 09:57'!
macroconstructionToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ macroToolbar ifNil: [
		macroToolbar := (self 
			newToolbarDropListFor:  (ListModel new list: self macroconstructionButtons)
			list: #list 
			getSelected: #selectionIndex 
			setSelected: #selectionIndex: 
			help: 'Build or execute macro-construction. A macro is a construction template you can apply to items in the sketch area.' translated)]! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 1/25/2012 20:10'!
mainMenu
	| menuBar |
	menuBar := self newToolDockingBar.
	menuBar
		add: 'File' translated
		font: self theme menuBarFont
		icon: nil
		help: 'Load, save or export Dr. Geo figure.' translated
		subMenu: self fileMenu.
	menuBar
		add: 'Edit' translated
		font: self theme menuBarFont
		icon: nil
		help: 'Erase or edit style and properties of items.' translated
		subMenu: self editMenu.
	menuBar 
		add: 'Points' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Create points: free, on curve, intersection or middle point.' translated 
		subMenu: self pointMenu.
	menuBar 
		add: 'Lines' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Create different curve types: line, half-line, segment, vector, circle...' translated 
		subMenu: self curveMenu.
	menuBar 
		add: 'Transformations' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Transform an object with a geometric transformation: symmetry, reflexion, rotation, translation or homothety (scale).' translated 
		subMenu: self transformationMenu.
	menuBar 
		add: 'Numerics' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Create several numeric objects: free value, distance, length, angle, coordinates, equation and script.' translated 
		subMenu: self numericMenu.
	menuBar 
		add: 'Macro-construction' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Build or execute macro-construction. A macro is a construction template you can apply to items in the sketch area.' translated 
		subMenu: self macroconstructionMenu.		
	^ menuBar 
! !

!DrGeoWindow methodsFor: '*DrGeoII-Polymorph-Widgets' stamp: 'HilaireFernandes 7/20/2012 11:46'!
newTabGroupTool: labelsAndPages
"Answer tab grouped tools with a the given tab labels associated with pages of tools"
	^(TabGroupToolMorph new
		font: self theme labelFont;
		cornerStyle: (self theme tabGroupCornerStyleIn: self);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		labelsAndPages: labelsAndPages)
		selectedPageIndex: (labelsAndPages isEmpty ifTrue: [0] ifFalse: [1])! !

!DrGeoWindow methodsFor: '*DrGeoII-Polymorph-Widgets' stamp: 'HilaireFernandes 7/20/2012 13:36'!
newTable: controls
"Answer a morph laid out with a table of controls, in row and wrapped in column."
	|answer|
	answer := PanelMorph new
		changeTableLayout;
		cellInset: 2;
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		cellPositioning: #topLeft.
	controls do: [:m | answer addMorphBack: m].
	^answer
			! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 8/3/2012 12:56'!
numericButtons
	| collection|
	collection := OrderedCollection withAll: {
		self buttonWith: self presenter distanceButtonData.
		self buttonWith: self presenter angleButtonData.
		self buttonWith: self presenter coordinatesButtonData.
		self buttonWith: self presenter textButtonData}.
	DrGDefault ifNotTablet: [
		collection addAll: 
			{self buttonWith: self presenter scriptEditButtonData.
			self buttonWith: self presenter scriptButtonData}].
	^ collection! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 8/3/2012 12:56'!
numericMenu
	| menu |
	menu := self newMenu.
	self addMenuItem: self presenter distanceButtonData to: menu.
	self addMenuItem: self presenter angleButtonData to: menu.
	self addMenuItem: self presenter coordinatesButtonData  to: menu.
	self addMenuItem: self presenter textButtonData  to: menu.
	self addMenuItem: self presenter scriptEditButtonData to: menu.
	self addMenuItem: self presenter scriptButtonData  to: menu.
	^ menu
		! !

!DrGeoWindow methodsFor: 'tabular groups' stamp: 'HilaireFernandes 8/3/2012 12:57'!
numericTab
	| collection |
	collection := OrderedCollection withAll: {
		self toolButtonFor: self presenter distanceButtonData .
		self toolButtonFor: self presenter angleButtonData .
		self toolButtonFor: self presenter coordinatesButtonData.
		self toolButtonFor: self presenter textButtonData}.
	DrGDefault ifNotTablet: [
		collection addAll: 
			{self toolButtonFor: self presenter scriptEditButtonData .
			self toolButtonFor: self presenter scriptButtonData }].
	^ self newTable: collection! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 7/3/2010 09:56'!
numericToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ numericToolbar ifNil: [
		numericToolbar := (self 
			newToolbarDropListFor:  (ListModel new list: self numericButtons)
			list: #list 
			getSelected: #selectionIndex 
			setSelected: #selectionIndex: 
			help: 'Create several numeric objects: free value, distance, length, angle, coordinates, equation and script.' translated)]! !

!DrGeoWindow methodsFor: '*DrGeoII-Polymorph-Widgets' stamp: 'HilaireFernandes 2/29/2012 10:53'!
openModal: aSystemWindow
	DrGDefault ifTablet: [
		aSystemWindow 
			extent: aSystemWindow initialExtent;
			topCentered;
			activate].
	^ super openModal: aSystemWindow.! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 10/30/2011 16:46'!
pointButtons
	^{
	self buttonWith: self presenter freePointButtonData.
	self buttonWith: self presenter middleButtonData.
	self buttonWith: self presenter intersectionButtonData.
	self buttonWith: self presenter pointByCoordinatesButtonData.
	}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 10/30/2011 16:44'!
pointMenu
	| pointMenu |
	pointMenu := self newMenu.
	self addMenuItem: self presenter freePointButtonData to: pointMenu.
	self addMenuItem: self presenter middleButtonData to: pointMenu.
	self addMenuItem: self presenter intersectionButtonData to: pointMenu.
	self addMenuItem: self presenter pointByCoordinatesButtonData  to: pointMenu.
	^ pointMenu
		! !

!DrGeoWindow methodsFor: 'tabular groups' stamp: 'HilaireFernandes 7/20/2012 13:37'!
pointTab
	^ self newTable: {
		self toolButtonFor: self presenter freePointButtonData.
		self toolButtonFor: self presenter middleButtonData.
		self toolButtonFor: self presenter intersectionButtonData.
		self toolButtonFor: self presenter pointByCoordinatesButtonData}! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/18/2012 09:33'!
pointToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ pointToolbar ifNil: [
		pointToolbar := self 
			newToolbarDropListFor:  (ListModel new list: self pointButtons )
			list: #list 
			getSelected: #selectionIndex 
			setSelected: #selectionIndex: 
			help: 'Create points: free, on curve, intersection or middle point.' translated]! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/26/2010 07:47'!
popupMenu 
"we don't want the popup menu when using the rich UI"! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2010 22:47'!
presenter 
	^ app presenter! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 10/4/2010 21:32'!
release
	super release.
	self presenter ifNotNil: [self presenter removeActionsWithReceiver: self].
	area release.
	area := nil.
	app := nil! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 5/22/2012 16:40'!
setStyler: morph
"set a morph to edit the style of an object, it can replace an existing one or add one such morph"
	sideContainer submorphsDo: [:aMorph|
			aMorph  ~= area ifTrue: [sideContainer removeMorph: aMorph]].
	morph 
		ifNotNil: [
			morph hResizing: #shrinkWrap; vResizing: #spaceFill.
			sideContainer submorphs size = 1 ifTrue: [sideContainer addMorph: self newVerticalSeparator].
			sideContainer addMorph: morph.
			self updatePaneColors]! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 9/19/2012 16:21'!
statusMessage: aString
	self statusbar submorphs first 
		contentsWrapped: aString! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 9/19/2012 15:58'!
statusbar
	^ statusbar
		ifNil: [| statuslabel |
			statusbar := self newPanel
				cellPositioning: #topRight;
				layoutInset: 0;
				cellInset: 0.
			statuslabel := self newText: ''.
			statuslabel autoFit: false;
				wrapFlag: true;
				vResizing: #spaceFill;
				hResizing: #spaceFill.
			statuslabel hasDropShadow: true;
				 shadowColor: Color gray;
				 shadowOffset: 1 @ 1.
			statusbar addMorphBack: statuslabel;
				vResizing: #shrinkWrap.
			statusbar]! !

!DrGeoWindow methodsFor: 'stepping' stamp: 'HilaireFernandes 2/25/2012 08:10'!
step
	DrGDefault ifTablet: [
		"track device rotation"
		self fullscreen].! !

!DrGeoWindow methodsFor: 'stepping' stamp: 'BertFreudenberg 6/28/2011 21:45'!
stepTime
	^ 1000
! !

!DrGeoWindow methodsFor: 'services' stamp: 'HilaireFernandes 2/22/2012 10:51'!
textEditor: aStringOrText title: aString entryText: defaultEntryText
|editor|
	"Answer the result of a text editor (multiline) dialog ( a string or nil if cancelled)
	with the given label and title."
	editor := TextEditorDialogWindow new
		textFont: self theme textFont;
		title: aString;
		text: aStringOrText;
		entryText: defaultEntryText;
		entryHeight: 150.
	DrGDefault ifTablet: [editor topCentered].
	^(self openModal: editor) entryText! !

!DrGeoWindow methodsFor: 'services' stamp: 'HilaireFernandes 2/22/2012 10:50'!
textEntry: aStringOrText title: aString xEntryText: xEntryText yEntryText: yEntryText
	|dialog|
	dialog := CoordinatesEditorDialogWindow new textFont: self theme textFont;
		title: aString; text: aStringOrText;
		xEntryText: xEntryText;	yEntryText: yEntryText.
	DrGDefault ifTablet: [dialog topCentered].
	"Open a text entry dialog."
	dialog := self openModal: dialog.
	^ {dialog xEntryText . dialog yEntryText}! !

!DrGeoWindow methodsFor: 'tabular groups' stamp: 'HilaireFernandes 7/20/2012 15:35'!
toolButtonFor: array
	^ self newButtonFor: self presenter 
		getState: #isTool:
		action: array third 
		arguments: {array second}
		getEnabled: nil
		label: array first 
		help: array fourth! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 7/21/2012 10:48'!
toolbarEvents
	self presenter
		when: #pointToolbar
		send: #updateContentsGraphic:
		to: self pointToolbar.
	self presenter
		when: #curveToolbar
		send: #updateContentsGraphic:
		to: self curveToolbar.
	self presenter
		when: #transformationToolbar
		send: #updateContentsGraphic:
		to: self transformationToolbar.
	self presenter
		when: #numericToolbar
		send: #updateContentsGraphic:
		to: self numericToolbar.
	self presenter
		when: #macroToolbar
		send: #updateContentsGraphic:
		to: self macroconstructionToolbar.! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 7/21/2012 10:47'!
toolbars
	^ toolbars ifNil: [
		toolbars := self newToolbar: {
		self pointToolbar. self newToolSpacer.
		self curveToolbar. self newToolSpacer.
		self transformationToolbar. self newToolSpacer.
		self numericToolbar. self newToolSpacer.
		self macroconstructionToolbar}.
	self newToolDockingBar addMorph: toolbars]! !

!DrGeoWindow methodsFor: 'tabular groups' stamp: 'HilaireFernandes 7/21/2012 10:47'!
toolsInTab
	| tabGroup |
	tabGroup := self newTabGroupTool: {
		'Points' translated -> 	self pointTab.
		'Lines' translated -> self curveTab.
		'Transformations' translated -> self transformationTab.
		'Numerics' translated -> self numericTab.
		'Macro-construction' translated -> self macroconstructionTab}.
	^ tabGroup
! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 7/2/2010 16:31'!
transformationButtons
	^{
	self buttonWith: self presenter symmetryButtonData.
	self buttonWith: self presenter reflectionButtonData.
	self buttonWith: self presenter translationButtonData.
	self buttonWith: self presenter rotationButtonData.
	self buttonWith: self presenter homothetyButtonData.
	}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/16/2010 17:43'!
transformationMenu
	| menu |
	menu := self newMenu.
	self addMenuItem: self presenter symmetryButtonData to: menu.
	self addMenuItem: self presenter reflectionButtonData to: menu.
	self addMenuItem: self presenter translationButtonData to: menu.
	self addMenuItem: self presenter rotationButtonData to: menu.
	self addMenuItem: self presenter homothetyButtonData to: menu.
	^ menu
		! !

!DrGeoWindow methodsFor: 'tabular groups' stamp: 'HilaireFernandes 7/20/2012 13:37'!
transformationTab
	^ self newTable: {
		self toolButtonFor: self presenter symmetryButtonData .
		self toolButtonFor: self presenter reflectionButtonData .
		self toolButtonFor: self presenter translationButtonData .
		self toolButtonFor: self presenter rotationButtonData .
		self toolButtonFor: self presenter homothetyButtonData }! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 7/3/2010 10:00'!
transformationToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ transformationToolbar ifNil: [
		transformationToolbar := (self 
			newToolbarDropListFor:  (ListModel new list: self transformationButtons )
			list: #list 
			getSelected: #selectionIndex 
			setSelected: #selectionIndex: 
			help: 'Transform an object with a geometric transformation: symmetry, reflexion, rotation, translation or homothety (scale).' translated)]! !

!DrGeoWindow methodsFor: 'stepping' stamp: 'HilaireFernandes 12/27/2011 00:03'!
wantsSteps
	^ DrGDefault isTablet! !

MorphDropListMorph subclass: #ToolbarDropListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!ToolbarDropListMorph methodsFor: 'list management' stamp: 'HilaireFernandes 5/3/2012 17:57'!
hideList
	^ self hideListSilently ! !

!ToolbarDropListMorph methodsFor: 'list management' stamp: 'HilaireFernandes 7/2/2010 14:43'!
hideListSilently
	"Hide the list without any update notificiation. "
	self listMorph ifNil: [^self].
	self listVisible ifFalse: [^self].
	self listMorph delete.
	self roundedCorners: #(1 2 3 4).
	(self buttonMorph ifNil: [^self]) roundedCorners: (self roundedCorners copyWithoutAll: #(1 2)).
	self changed.
	self wantsKeyboardFocus
		ifTrue: [self takeKeyboardFocus]! !

!ToolbarDropListMorph methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2012 11:04'!
list: aCollection
	"Set the list contents."
	| maxExtent |
	maxExtent := 0@0.
	list := aCollection.
	list do: [:aMorph | aMorph lock.
		maxExtent := maxExtent max: aMorph extent].
	self contentMorph;
		minWidth: maxExtent x;
		minHeight: maxExtent y.
	self changed: #list.
	self listSelectionIndex: 1! !

!ToolbarDropListMorph methodsFor: 'accessing' stamp: 'HilaireFernandes 4/8/2010 21:20'!
listHeight
	"Answer the height for the list."
	^self listMorph listMorph height + 19! !

!ToolbarDropListMorph methodsFor: 'list management' stamp: 'HilaireFernandes 4/9/2010 09:39'!
listMorphClass
	"Answer the class for a new list morph"

	^PluggableToolbarMorph! !

!ToolbarDropListMorph methodsFor: 'list management' stamp: 'HilaireFernandes 7/2/2010 17:17'!
listMouseDown: evt
	"Click outside the list."

	(self listMorph fullContainsPoint: evt position)
		ifTrue: [self listMorph selectionIndex: (self listMorph rowAtLocation: evt position)]
		ifFalse: [self hideListSilently]! !

!ToolbarDropListMorph methodsFor: 'initialize-release' stamp: 'HilaireFernandes 7/12/2010 22:15'!
listSelectionIndexSilently: anInteger
	"Set the list selection."
	self hideList.
	anInteger = 0 ifTrue: [^self].
	listSelectionIndex := anInteger.
	self
		changed: #listSelectionIndex;
		updateContentsGraphic;
		triggerEvent: #selectionIndex with: anInteger.
	self model ifNotNil: [:m | 
		self setIndexSelector ifNotNil: [:s |
			self useSelectionIndex
				ifTrue: [m perform: s with: anInteger]
				ifFalse: [m perform: s with: self selectedItem]]]! !

!ToolbarDropListMorph methodsFor: 'initialize-release' stamp: 'HilaireFernandes 7/12/2010 22:16'!
listSilently: aCollection
	"Set the list contents."
	| maxExtent |
	maxExtent := 0@0.
	list := aCollection.
	list do: [:aMorph | aMorph lock.
		maxExtent := maxExtent max: aMorph extent].
	self contentMorph;
		minWidth: maxExtent x;
		minHeight: maxExtent y.
	self changed: #list.
	self listSelectionIndexSilently: 1.! !

!ToolbarDropListMorph methodsFor: 'user interface' stamp: 'HilaireFernandes 4/18/2012 19:01'!
newContentMorph
	 "answer a new content morph"
	^Morph new
		changeTableLayout;
		listDirection: #leftToRight;
		wrapCentering: #center;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		layoutInset: 0;
		color: Color transparent;
		borderWidth: 0;
		clipSubmorphs: true! !

!ToolbarDropListMorph methodsFor: 'initialize-release' stamp: 'HilaireFernandes 7/12/2010 22:12'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel
	"Set the receiver to the given model parameterized by the given message selectors."

	getListSel isSymbol
		ifTrue: [self  getListSelector: getListSel]
		ifFalse: [self list: getListSel]. "allow direct list"
	self
		model: anObject;
		getIndexSelector: getSelectionSel;
		setIndexSelector: setSelectionSel;
		updateListSilently;
		updateListSelectionIndex;
		updateContentsGraphic ! !

!ToolbarDropListMorph methodsFor: 'initialize-release' stamp: 'HilaireFernandes 4/18/2012 11:58'!
showListAfterLongClick
	self contentMorph firstSubmorph
		showSelectionFeedback: false;
		changed.
	self showList.

	! !

!ToolbarDropListMorph methodsFor: 'initialize-release' stamp: 'HilaireFernandes 5/3/2012 17:29'!
updateContents
	"Update the contents (graphic + execute callback)."

	|item| 
	item := self updateContentsGraphic.
	item ifNotNil: [item performAction]! !

!ToolbarDropListMorph methodsFor: 'initialize-release' stamp: 'HilaireFernandes 7/3/2010 10:41'!
updateContentsGraphic
	"Update the graphic contents."
	^ self updateContentsGraphic: self listSelectionIndex! !

!ToolbarDropListMorph methodsFor: 'initialize-release' stamp: 'HilaireFernandes 4/18/2012 09:56'!
updateContentsGraphic: integer
	"Update the graphic contents with the integer nth element of the list."

	|item| 
	self contentMorph removeAllMorphs.
	^ integer > 0
		ifTrue: [
			item := (self list at: integer) copy unlock;
				hResizing: #spaceFill;
				vResizing: #spaceFill.
			self contentMorph
				addMorph: item.
			item on: #mouseStillDown send: #showListAfterLongClick to: self.
			item]
		ifFalse: [nil]! !

!ToolbarDropListMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/12/2010 21:53'!
updateListSelectionIndex
	"Update the list selection."

	|i|
	self useSelectionIndex
		ifTrue: [i := self getCurrentSelectionIndex.
				listSelectionIndex == i ifTrue: [^self].
				listSelectionIndex := i]
		ifFalse: [i := self getCurrentSelection.
				listSelectionIndex := i isNil
					ifTrue: [0]
					ifFalse: [self list indexOf: i]].
	self
		changed: #listSelectionIndex;
		updateContentsGraphic;
		triggerEvent: #selectionIndex with: i! !

!ToolbarDropListMorph methodsFor: 'initialize-release' stamp: 'HilaireFernandes 7/12/2010 22:16'!
updateListSilently
	"Refresh the list."

	self getListSelector isSymbol ifTrue: [
		self listSilently: (self model perform: self getListSelector).
		listSelectionIndex := 0]! !

FileDialogWindow subclass: #DrGFileDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!DrGFileDialogWindow methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 8/25/2010 22:38'!
newPreviewMorph
	"Answer a new preview morph."
	| aMorph |
	aMorph := super newPreviewMorph.
	self previewType == #drgeo ifTrue: [aMorph := self newImagePreviewMorph].
	^ aMorph.! !

!DrGFileDialogWindow methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 12/21/2011 09:11'!
previewSize
	| aSize |
	aSize := super previewSize.
	self previewType == #drgeo ifTrue: [aSize := DrGeo previewSize].
	^ aSize! !

!DrGFileDialogWindow methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 12/21/2011 09:11'!
updateDrGeoPreview
	| str aDrgeo |
	str := self openSelectedFile.
	str ifNil: [^self].
	[[aDrgeo := (DrGeoXml new loadOnlyFigureFrom: str for: #service) first.
	  aDrgeo view openInWorld; delete]
		on: Error do: []]
		ensure: [str close].
	self previewMorph
		image: (aDrgeo ifNil: [Form extent: 1@1] ifNotNil: [aDrgeo area imageForm])
		size: DrGeo previewSize! !

!DrGFileDialogWindow methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 8/25/2010 22:24'!
updatePreview
	super updatePreview.
	self previewType == #drgeo ifTrue: [self updateDrGeoPreview]
	! !

TextEntryDialogWindow subclass: #DrGFilenameDialogWindow
	instanceVariableNames: 'networked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!DrGFilenameDialogWindow commentStamp: 'HilaireFernandes 12/19/2011 13:57' prior: 0!
- networked : a checkbox to enable or not network save operation!

!DrGFilenameDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 12/19/2011 13:59'!
network 
	^ networked ifNil: [networked := false]! !

!DrGFilenameDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 11/21/2012 21:26'!
network: boolean
	networked := boolean.
	self  changed: #network! !

!DrGFilenameDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 11/21/2012 21:16'!
networkShare! !

!DrGFilenameDialogWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 11/21/2012 21:17'!
networkShare: aString! !

!DrGFilenameDialogWindow methodsFor: 'actions' stamp: 'HilaireFernandes 11/21/2012 21:27'!
newCheckboxMorph
	^ self 
		newCheckboxFor:  self
		getSelected: #network 
		setSelected: #network:
		label: 'Network share' translated
		help: 'Save the file on a network share.' translated! !

!DrGFilenameDialogWindow methodsFor: 'actions' stamp: 'HilaireFernandes 11/21/2012 21:18'!
newContentMorph
	"Answer a new content morph."
	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	self textMorph wrapFlag: false.
	self textEditorMorph: self newTextEditorMorph.
	^ DrGDefault useNetwork 
		ifTrue: [
			self newGroupboxForAll: {
				self newRow: {self iconMorph. self textMorph}.
				self textEditorMorph.
				self newRow: {self newCheckboxMorph. self newNetworkShareMorph}}] 
		ifFalse: [
			self newGroupboxForAll: {
				self newRow: {self iconMorph. self textMorph}.
				self textEditorMorph}]
! !

!DrGFilenameDialogWindow methodsFor: 'actions' stamp: 'HilaireFernandes 11/21/2012 21:25'!
newNetworkShareMorph
	^ self 
		newTextEntryFor: self 
		getText: #networkShare
		setText: #networkShare:
		getEnabled: #network
		help: 'Name of the network share.' translated

! !

MenuMorph subclass: #DrGCanvasMenuMorph
	instanceVariableNames: 'costumes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!DrGCanvasMenuMorph commentStamp: 'HilaireFernandes 11/19/2012 07:14' prior: 0!
A DrGCanvasMenu is a popup menu for the canvas. Its menu items are costumes of the canvas. When a menu item is highlighted, the matching costume in the canvas is emphasised as well.
!

!DrGCanvasMenuMorph class methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 11/19/2012 07:45'!
chooseFrom: aList lines: linesArray title: queryString
	"Choose an item from the given list. Answer the index of the selected item."
	"MenuMorph
		chooseFrom: #('Hello' 'Pharoers' 'Here' 'We' 'Go')
		lines: #(2 4)
		title: 'What''s up?'"
		
	| menu result |
	(ProvideAnswerNotification signal: queryString) ifNotNil:[:answer | 
		1 to: aList size do:[:i| (aList at: i) = answer ifTrue:[^i]].
		^0].
	result := 0.
	menu := self new.
	menu costumes: aList.
	menu addTitle: queryString.
	1 to: aList size do:[:i| 
		menu add: (aList at: i) asString target: [:v| result := v] selector: #value: argument: i.
		(linesArray includes: i) ifTrue: [menu addLine]].
	
	menu invokeAt: ActiveHand position in: ActiveWorld allowKeyboard: true.
	^result! !

!DrGCanvasMenuMorph methodsFor: 'accessing' stamp: 'HilaireFernandes 11/19/2012 07:16'!
costumes: aCollection
	costumes := aCollection! !

!DrGCanvasMenuMorph methodsFor: 'control' stamp: 'HilaireFernandes 11/19/2012 08:21'!
selectItem: aMenuItem event: anEvent
	selectedItem ifNotNil:[
		selectedItem deselect: anEvent.
		(costumes at: selectedItem arguments first) stopBlinking].
	selectedItem := aMenuItem.
	selectedItem ifNotNil:[
		selectedItem select: anEvent.
		(costumes at: selectedItem arguments first) startBlinking].! !

!TabGroupMorph methodsFor: '*DrGeoII-Polymorph' stamp: 'HilaireFernandes 7/20/2012 13:42'!
newContentMorph
	"Answer a new content morph"

	|p|
	p := PanelMorph new
		roundedCorners: #(2 3 4);
		changeTableLayout; 
		layoutInset: (4@4 corner: 4@4);
		cellInset: 8;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill.
	p borderStyle: (self theme tabPanelBorderStyleFor: self).
	^p! !

!TabGroupMorph methodsFor: '*DrGeoII-Polymorph' stamp: 'HilaireFernandes 7/21/2012 10:35'!
pageMorph
	"Answer the current page morph if any."
	^ self contentMorph ifNotNilDo: [:morph| 
		morph hasSubmorphs ifTrue: [self contentMorph submorphs first]]! !

TabGroupMorph subclass: #TabGroupToolMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!TabGroupToolMorph commentStamp: 'HilaireFernandes 7/20/2012 11:39' prior: 0!
I am tab group to host tools populated in tabs. Each tools is a button, covered in several lines.!

!TabGroupToolMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/20/2012 15:57'!
addPage: aMorph label: aStringOrMorph
	"Add a page and its tab."
	aMorph
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	self pages add: aMorph.
	self tabSelectorMorph addTab: aStringOrMorph.
	aMorph submorphsDo: [:aButton |
		aButton model when: #selectedToolFromTab send: #hideTools to: self]! !

!TabGroupToolMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/20/2012 15:57'!
hideTools
	self contentMorph hide.! !

!TabGroupToolMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/27/2012 09:26'!
layoutChanged
	super layoutChanged.
	self comeToFront.
	self pageMorph ifNotNilDo: [:pm |
		self owner ifNotNil: [pm width: (pm width min: self owner width)]]! !

!TabGroupToolMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/20/2012 14:17'!
minExtent
	"Calculate the min extent of the receiver based only on the tabSelector."
	^ self tabSelectorMorph minExtent! !

!TabGroupToolMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/20/2012 16:14'!
newTabSelectorMorph
	"Answer a new tab selector morph"

	^TabToolSelectorMorph new
		vResizing: #shrinkWrap;
		hResizing: #spaceFill! !

!TabGroupToolMorph methodsFor: 'updating' stamp: 'HilaireFernandes 7/20/2012 17:24'!
update: aSymbol with: oldIndex
	"Handle tab changes."
	aSymbol == #selectedIndex
		ifTrue: [self updatePageIndex: self selectedPageIndex oldIndex: oldIndex]! !

!TabGroupToolMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/21/2012 10:38'!
updatePageIndex: index
	"Change to the given page index."

	self pageMorph ifNotNil: [:p | self contentMorph removeMorph: p].
	index > 0 ifTrue: [self contentMorph addMorph: (self pages at: index)].
	self pageMorph ifNotNil: [:pm | 
		self owner ifNotNil: 
			[pm width: (pm width min: self owner width).
			pm layoutChanged]].
	self adoptPaneColor: self paneColor! !

!TabGroupToolMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/20/2012 17:39'!
updatePageIndex: index oldIndex: oldIndex
	index == oldIndex
		ifTrue:  [self contentMorph toggleVisible]
		ifFalse: [self contentMorph show].
	self updatePageIndex: index.! !

TabSelectorMorph subclass: #TabToolSelectorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!TabToolSelectorMorph methodsFor: 'accessing' stamp: 'HilaireFernandes 7/20/2012 16:32'!
selectedIndex: index
	
	"Set the value of selectedIndex"

	|oldIndex|
	oldIndex := selectedIndex.
	selectedIndex == index ifTrue: [	^ self changed: #selectedIndex with: oldIndex].
	selectedIndex := (index min: self tabs size).
	self visibleTabRange first > index
		ifTrue: [self visibleTabRange: ((index max: 1) to: 0)]
		ifFalse: [self visibleTabRange last < index
				ifTrue: [self visibleTabRange: (0 to: index)]].
	self updateTabs.
	self changed: #selectedIndex with: oldIndex! !

ProceedDialogWindow subclass: #SelectItemDialogWindow
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!SelectItemDialogWindow commentStamp: 'HilaireFernandes 10/4/2010 22:21' prior: 0!
A SelectItemDialogWindow is a dialog with a list of item and checkboxes to select or unselect the items.

Instance Variables
 model is an array of 3 cells arrays: {model .  title . ValueHolder}
!

!SelectItemDialogWindow class methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 10/4/2010 22:35'!
items: items
	 ^ self basicNew 
		items: items;
		initialize! !

!SelectItemDialogWindow methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 10/4/2010 22:35'!
items: array
	items := array ! !

!SelectItemDialogWindow methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 10/4/2010 22:31'!
newContentMorph
	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	^self newGroupboxForAll: {
		self newRow: {self iconMorph. self textMorph}.
		self newTableMorph}! !

!SelectItemDialogWindow methodsFor: 'controls' stamp: 'HilaireFernandes 10/4/2010 22:02'!
newItem: array
	^ self newColumn: {
		self newCheckboxFor: (array at: 3 put: (ValueHolder new contents: false))
			getSelected: #contents setSelected: #contents:
			label: array second help: nil
	}! !

!SelectItemDialogWindow methodsFor: 'controls' stamp: 'HilaireFernandes 10/4/2010 22:35'!
newTableMorph
	^self newColumn: (items collect: [:item | self newItem: item])! !
DrGDistroInfo initialize!
